Oboe 1.2 A library for creating real-time audio apps on Android

Public Member Functions | Static Public Member Functions | List of all members
oboe::AudioStreamBuilder Class Reference

`#include <AudioStreamBuilder.h>`

Inheritance diagram for oboe::AudioStreamBuilder:

## Public Member Functions
| AudioStreamBuilder (const AudioStreamBase &audioStreamBase)
AudioStreamBuilder * | setChannelCount (int channelCount)
AudioStreamBuilder * | setDirection (Direction direction)
AudioStreamBuilder * | setSampleRate (int32_t sampleRate)
AudioStreamBuilder * | setFramesPerCallback (int framesPerCallback)
AudioStreamBuilder * | setFormat (AudioFormat format)
AudioStreamBuilder * | setBufferCapacityInFrames (int32_t bufferCapacityInFrames)
AudioApi | getAudioApi () const
AudioStreamBuilder * | setAudioApi (AudioApi audioApi)
AudioStreamBuilder * | setSharingMode (SharingMode sharingMode)
AudioStreamBuilder * | setPerformanceMode (PerformanceMode performanceMode)
AudioStreamBuilder * | setUsage (Usage usage)
AudioStreamBuilder * | setContentType (ContentType contentType)
AudioStreamBuilder * | setInputPreset (InputPreset inputPreset)
AudioStreamBuilder * | setSessionId (SessionId sessionId)
AudioStreamBuilder * | setDeviceId (int32_t deviceId)
AudioStreamBuilder * | setCallback (AudioStreamCallback *streamCallback)
AudioStreamBuilder * | setChannelConversionAllowed (bool allowed)
AudioStreamBuilder * | setFormatConversionAllowed (bool allowed)
AudioStreamBuilder * | setSampleRateConversionQuality (SampleRateConversionQuality quality)
bool | willUseAAudio () const
Result | openStream (AudioStream **stream)
Result | openManagedStream (ManagedStream &stream)
Public Member Functions inherited from oboe::AudioStreamBase
| AudioStreamBase (const AudioStreamBase &)=default
AudioStreamBase & | operator= (const AudioStreamBase &)=default
int32_t | getChannelCount () const
Direction | getDirection () const
int32_t | getSampleRate () const
int32_t | getFramesPerCallback () const
AudioFormat | getFormat () const
virtual int32_t | getBufferSizeInFrames ()
virtual int32_t | getBufferCapacityInFrames () const
SharingMode | getSharingMode () const
PerformanceMode | getPerformanceMode () const
int32_t | getDeviceId () const
AudioStreamCallback * | getCallback () const
Usage | getUsage () const
ContentType | getContentType () const
InputPreset | getInputPreset () const
SessionId | getSessionId () const
bool | isChannelConversionAllowed () const
bool | isFormatConversionAllowed () const
SampleRateConversionQuality | getSampleRateConversionQuality () const

## Static Public Member Functions
static bool | isAAudioSupported ()
static bool | isAAudioRecommended ()

## Additional Inherited Members
Protected Attributes inherited from oboe::AudioStreamBase
AudioStreamCallback * | mStreamCallback = nullptr
int32_t | mFramesPerCallback = kUnspecified
int32_t | mChannelCount = kUnspecified
int32_t | mSampleRate = kUnspecified
int32_t | mDeviceId = kUnspecified
int32_t | mBufferCapacityInFrames = kUnspecified
int32_t | mBufferSizeInFrames = kUnspecified
int32_t | mFramesPerBurst = kUnspecified
SharingMode | mSharingMode = SharingMode::Shared
AudioFormat | mFormat = AudioFormat::Unspecified
Direction | mDirection = Direction::Output
PerformanceMode | mPerformanceMode = PerformanceMode::None
Usage | mUsage = Usage::Media
ContentType | mContentType = ContentType::Music
InputPreset | mInputPreset = InputPreset::VoiceRecognition
SessionId | mSessionId = SessionId::None
bool | mChannelConversionAllowed = false
bool | mFormatConversionAllowed = false
SampleRateConversionQuality | mSampleRateConversionQuality = SampleRateConversionQuality::None

## Detailed Description

Factory class for an audio Stream.

## Member Function Documentation

## ◆ getAudioApi()

AudioApi oboe::AudioStreamBuilder::getAudioApi | ( |  | ) | const
| inline

Get the audio API which will be requested when opening the stream. No guarantees that this is the API which will actually be used. Query the stream itself to find out the API which is being used.

If you do not specify the API, then AAudio will be used if isAAudioRecommended() returns true. Otherwise OpenSL ES will be used.

Returns
  the requested audio API

## ◆ isAAudioRecommended()

static bool oboe::AudioStreamBuilder::isAAudioRecommended | ( |  | ) |
| static

Is the AAudio API recommended this device?

AAudio may be supported but not recommended because of version specific issues. AAudio is not recommended for Android 8.0 or earlier versions.

Returns
  true if recommended

## ◆ isAAudioSupported()

static bool oboe::AudioStreamBuilder::isAAudioSupported | ( |  | ) |
| static

Is the AAudio API supported on this device?

AAudio was introduced in the Oreo 8.0 release.

Returns
  true if supported

## ◆ openManagedStream()

Result oboe::AudioStreamBuilder::openManagedStream | ( | ManagedStream & | stream | ) |

Create and open a ManagedStream object based on the current builder state.

The caller must create a unique ptr, and pass by reference so it can be modified to point to an opened stream. The caller owns the unique ptr, and it will be automatically closed and deleted when going out of scope.

Parameters

  stream | Reference to the ManagedStream (uniqueptr) used to keep track of stream

Returns
  OBOE_OK if successful or a negative error code.

## ◆ openStream()

Result oboe::AudioStreamBuilder::openStream | ( | AudioStream ** | stream | ) |

Create and open a stream object based on the current settings.

The caller owns the pointer to the AudioStream object.

Parameters

  stream | pointer to a variable to receive the stream address

Returns
  OBOE_OK if successful or a negative error code

## ◆ setAudioApi()

AudioStreamBuilder* oboe::AudioStreamBuilder::setAudioApi | ( | AudioApi | audioApi | ) |
| inline

If you leave this unspecified then Oboe will choose the best API for the device and SDK version at runtime.

This should almost always be left unspecified, except for debugging purposes. Specifying AAudio will force Oboe to use AAudio on 8.0, which is extremely risky. Specifying OpenSLES should mainly be used to test legacy performance/functionality.

If the caller requests AAudio and it is supported then AAudio will be used.

Parameters

  audioApi | Must be AudioApi::Unspecified, AudioApi::OpenSLES or AudioApi::AAudio.

Returns
  pointer to the builder so calls can be chained

## ◆ setBufferCapacityInFrames()

AudioStreamBuilder* oboe::AudioStreamBuilder::setBufferCapacityInFrames | ( | int32_t | bufferCapacityInFrames | ) |
| inline

Set the requested buffer capacity in frames. BufferCapacityInFrames is the maximum possible BufferSizeInFrames.

The final stream capacity may differ. For AAudio it should be at least this big. For OpenSL ES, it could be smaller.

Default is kUnspecified.

Parameters

  bufferCapacityInFrames | the desired buffer capacity in frames or kUnspecified

Returns
  pointer to the builder so calls can be chained

## ◆ setCallback()

AudioStreamBuilder* oboe::AudioStreamBuilder::setCallback | ( | AudioStreamCallback * | streamCallback | ) |
| inline

Specifies an object to handle data or error related callbacks from the underlying API.

Important: See AudioStreamCallback for restrictions on what may be called from the callback methods.

When an error callback occurs, the associated stream will be stopped and closed in a separate thread.

A note on why the streamCallback parameter is a raw pointer rather than a smart pointer:

The caller should retain ownership of the object streamCallback points to. At first glance weak_ptr may seem like a good candidate for streamCallback as this implies temporary ownership. However, a weak_ptr can only be created from a shared_ptr. A shared_ptr incurs some performance overhead. The callback object is likely to be accessed every few milliseconds when the stream requires new data so this overhead is something we want to avoid.

This leaves a raw pointer as the logical type choice. The only caveat being that the caller must not destroy the callback before the stream has been closed.

Parameters

  streamCallback |

Returns
  pointer to the builder so calls can be chained

## ◆ setChannelConversionAllowed()

AudioStreamBuilder* oboe::AudioStreamBuilder::setChannelConversionAllowed | ( | bool | allowed | ) |
| inline

If true then Oboe might convert channel counts to achieve optimal results. On some versions of Android for example, stereo streams could not use a FAST track. So a mono stream might be used instead and duplicated to two channels. On some devices, mono streams might be broken, so a stereo stream might be opened and converted to mono.

Default is true.

## ◆ setChannelCount()

AudioStreamBuilder* oboe::AudioStreamBuilder::setChannelCount | ( | int | channelCount | ) |
| inline

Request a specific number of channels.

Default is kUnspecified. If the value is unspecified then the application should query for the actual value after the stream is opened.

## ◆ setContentType()

AudioStreamBuilder* oboe::AudioStreamBuilder::setContentType | ( | ContentType | contentType | ) |
| inline

Set the type of audio data that the stream will carry.

The system will use this information to optimize the behavior of the stream. This could, for example, affect whether a stream is paused when a notification occurs.

The default, if you do not call this function, is ContentType::Music.

Added in API level 28.

Parameters

  contentType | the type of audio data, eg. ContentType::Speech

## ◆ setDeviceId()

AudioStreamBuilder* oboe::AudioStreamBuilder::setDeviceId | ( | int32_t | deviceId | ) |
| inline

Request a stream to a specific audio input/output device given an audio device ID.

In most cases, the primary device will be the appropriate device to use, and the deviceId can be left kUnspecified.

On Android, for example, the ID could be obtained from the Java AudioManager. AudioManager.getDevices() returns an array of AudioDeviceInfo[], which contains a getId() method (as well as other type information), that should be passed to this method.

Note that when using OpenSL ES, this will be ignored and the created stream will have deviceId kUnspecified.

Parameters

  deviceId | device identifier or kUnspecified

Returns
  pointer to the builder so calls can be chained

## ◆ setDirection()

AudioStreamBuilder* oboe::AudioStreamBuilder::setDirection | ( | Direction | direction | ) |
| inline

Request the direction for a stream. The default is Direction::Output.

Parameters

  direction | Direction::Output or Direction::Input

## ◆ setFormat()

AudioStreamBuilder* oboe::AudioStreamBuilder::setFormat | ( | AudioFormat | format | ) |
| inline

Request a sample data format, for example Format::Float.

Default is Format::Unspecified. If the value is unspecified then the application should query for the actual value after the stream is opened.

## ◆ setFormatConversionAllowed()

AudioStreamBuilder* oboe::AudioStreamBuilder::setFormatConversionAllowed | ( | bool | allowed | ) |
| inline

If true then Oboe might convert data formats to achieve optimal results. On some versions of Android, for example, a float stream could not get a low latency data path. So an I16 stream might be opened and converted to float.

Default is true.

## ◆ setFramesPerCallback()

AudioStreamBuilder* oboe::AudioStreamBuilder::setFramesPerCallback | ( | int | framesPerCallback | ) |
| inline

Request a specific number of frames for the data callback.

Default is kUnspecified. If the value is unspecified then the actual number may vary from callback to callback.

If an application can handle a varying number of frames then we recommend leaving this unspecified. This allow the underlying API to optimize the callbacks. But if your application is, for example, doing FFTs or other block oriented operations, then call this function to get the sizes you need.

Parameters

  framesPerCallback |

Returns
  pointer to the builder so calls can be chained

## ◆ setInputPreset()

AudioStreamBuilder* oboe::AudioStreamBuilder::setInputPreset | ( | InputPreset | inputPreset | ) |
| inline

Set the input (capture) preset for the stream.

The system will use this information to optimize the behavior of the stream. This could, for example, affect which microphones are used and how the recorded data is processed.

The default, if you do not call this function, is InputPreset::VoiceRecognition. That is because VoiceRecognition is the preset with the lowest latency on many platforms.

Added in API level 28.

Parameters

  inputPreset | the desired configuration for recording

## ◆ setPerformanceMode()

AudioStreamBuilder* oboe::AudioStreamBuilder::setPerformanceMode | ( | PerformanceMode | performanceMode | ) |
| inline

Request a performance level for the stream. This will determine the latency, the power consumption, and the level of protection from glitches.

Parameters

  performanceMode | for example, PerformanceMode::LowLatency

Returns
  pointer to the builder so calls can be chained

## ◆ setSampleRate()

AudioStreamBuilder* oboe::AudioStreamBuilder::setSampleRate | ( | int32_t | sampleRate | ) |
| inline

Request a specific sample rate in Hz.

Default is kUnspecified. If the value is unspecified then the application should query for the actual value after the stream is opened.

Technically, this should be called the "frame rate" or "frames per second", because it refers to the number of complete frames transferred per second. But it is traditionally called "sample rate". Se we use that term.

## ◆ setSampleRateConversionQuality()

AudioStreamBuilder* oboe::AudioStreamBuilder::setSampleRateConversionQuality | ( | SampleRateConversionQuality | quality | ) |
| inline

Specify the quality of the sample rate converter in Oboe.

If set to None then Oboe will not do sample rate conversion. But the underlying APIs might still do sample rate conversion if you specify a sample rate. That can prevent you from getting a low latency stream.

If you do the conversion in Oboe then you might still get a low latency stream.

Default is SampleRateConversionQuality::None

## ◆ setSessionId()

AudioStreamBuilder* oboe::AudioStreamBuilder::setSessionId | ( | SessionId | sessionId | ) |
| inline

Set the requested session ID.

The session ID can be used to associate a stream with effects processors. The effects are controlled using the Android AudioEffect Java API.

The default, if you do not call this function, is SessionId::None.

If set to SessionId::Allocate then a session ID will be allocated when the stream is opened.

The allocated session ID can be obtained by calling AudioStream::getSessionId() and then used with this function when opening another stream. This allows effects to be shared between streams.

Session IDs from Oboe can be used the Android Java APIs and vice versa. So a session ID from an Oboe stream can be passed to Java and effects applied using the Java AudioEffect API.

Allocated session IDs will always be positive and nonzero.

Added in API level 28.

Parameters

  sessionId | an allocated sessionID or SessionId::Allocate

## ◆ setSharingMode()

AudioStreamBuilder* oboe::AudioStreamBuilder::setSharingMode | ( | SharingMode | sharingMode | ) |
| inline

Request a mode for sharing the device. The requested sharing mode may not be available. So the application should query for the actual mode after the stream is opened.

Parameters

  sharingMode | SharingMode::Shared or SharingMode::Exclusive

Returns
  pointer to the builder so calls can be chained

## ◆ setUsage()

AudioStreamBuilder* oboe::AudioStreamBuilder::setUsage | ( | Usage | usage | ) |
| inline

Set the intended use case for the stream.

The system will use this information to optimize the behavior of the stream. This could, for example, affect how volume and focus is handled for the stream.

The default, if you do not call this function, is Usage::Media.

Added in API level 28.

Parameters

  usage | the desired usage, eg. Usage::Game

## ◆ willUseAAudio()

bool oboe::AudioStreamBuilder::willUseAAudio | ( |  | ) | const
| inline

Returns
  true if AAudio will be used based on the current settings.

The documentation for this class was generated from the following file:

- include/oboe/AudioStreamBuilder.h